package monopoly.gui;

/**
 * Titre :        Monopoly - version 3 - graphique
 * Description :
 * Copyright :    Copyright (c) 2001
 * Socit :      ***
 * @author Emmanuel DURIN
 * @version 1.0
 */
import monopoly.plateau.Case;
import monopoly.joueur.*;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.AffineTransform;
import java.awt.font.*;
import java.awt.geom.*;

public class CaseG {
  protected static final int HAUTEUR_ENTETE = 16;
  private MonopolyPanel _panel;
  protected Case _case;
  static final String _font = "Arial Narrow";//"Helvetica"; //"System"; //"Arial Narrow";
  static int style = Font.PLAIN;
  static final int LARGEUR_CASE = 40;
  static final int HAUTEUR_CASE = 66;
  public CaseG( ) {
  }
  public CaseG( Case c ) {
    _case = c;
  }
  public void setCase( Case c)
  {
     _case = c;
  }
  public void dessineCadre(  Graphics2D g2, int posx, int posy)
  {
    g2.setColor(Color.black );
    g2.drawRect(posx,posy, LARGEUR_CASE, HAUTEUR_CASE);
  }
  void dessineJoueurs(  Graphics2D g2, AffineTransform t , int centreX, int centreY )
  {
    int j = 0;
    int nbJoueurs = _case.getListeJoueurs().size();
    int nbLignes = (nbJoueurs+1)/2;
    // centre dans la case

    final int LARGEUR_LIGNE = 12;
    final int HAUTEUR_LIGNE = 12;
    for(Iterator i = _case.getListeJoueurs().iterator() ;i.hasNext(); j ++){
      int nbDansLaLigne = (j == nbJoueurs-1 && ((nbJoueurs %2 ) == 1) ? 1: 2);
      Joueur joueur = (Joueur) i.next();

      int y = centreY -(nbLignes-1)*HAUTEUR_LIGNE/2 + j/2*HAUTEUR_LIGNE;
      int x = centreX + -((nbDansLaLigne+1)%2)*LARGEUR_LIGNE/2 + LARGEUR_LIGNE*(j%2 );

      joueur.getJoueurG().dessine( g2, x, y);
    }
  }
  public void dessineCase( Graphics2D g2, AffineTransform t , int posx, int posy, boolean bErase)
  {
    g2.setTransform(t);
    g2.setColor( Color.white );
    g2.fillRect(posx, posy, LARGEUR_CASE, HAUTEUR_CASE);
    g2.setColor(Color.black );

    dessineCadre(g2, posx,posy);

    dessineTexte( _case.toString(),g2, new Point(posx  +LARGEUR_CASE/40  ,
      posy/*+HAUTEUR_CASE*1/40*/),
      new Dimension(LARGEUR_CASE*19/20, HAUTEUR_CASE*8/10/2) );
    dessineJoueurs(  g2, t , posx+LARGEUR_CASE/2, posy+HAUTEUR_CASE/2 );
  }
  /**
   * Permet de dessiner les cases qui sont au coins du jeu
   */
  public void dessineCoin( Graphics2D g2, AffineTransform t , int x, int y)
  {
    g2.setTransform(t);
    g2.setColor( Color.white );
    g2.fillRect(x -HAUTEUR_CASE +LARGEUR_CASE,
      y,
      HAUTEUR_CASE,
      HAUTEUR_CASE);
    g2.setColor( Color.black );
    g2.drawRect(x -HAUTEUR_CASE +LARGEUR_CASE,
      y,
      HAUTEUR_CASE,
      HAUTEUR_CASE);

    dessineTexte(_case.toString(), g2, new Point(
      x -HAUTEUR_CASE +LARGEUR_CASE
      +HAUTEUR_CASE/10,
      y +HAUTEUR_CASE*2/5) ,
      new Dimension(HAUTEUR_CASE*8/10, HAUTEUR_CASE/5 )
    );
    dessineJoueurs(g2,t ,x+HAUTEUR_CASE/2  -HAUTEUR_CASE +LARGEUR_CASE ,y+HAUTEUR_CASE/2 );
  }
  /**
   * Dessine du texte centr dans un cadre en s'aidant de @see TextSplitter
   */
  protected void dessineTexte( String sToDraw , Graphics2D g2, Point p , Dimension d  )
  {
    if ( sToDraw == null || sToDraw.equals("") )
      return ;
    Rectangle2D         rect;
    FontRenderContext   frc;
    Font                f;
    double              fontSize = 8;
    double              ratio = 10000000000000.0;
    TextSplitter        t = new TextSplitter(sToDraw);
    double              height = 10000000.0;
    frc = g2.getFontRenderContext();
    while ( t.hasNext() ) {
      String s = t.next();
      f = new Font(_font, (int) (style ),(int)fontSize);
      g2.setFont( f );
      rect = f.getStringBounds(s, frc);
      double xRatio = rect.getWidth() == 0 ? 0 : d.getWidth()/rect.getWidth() ;
      double yRatio = rect.getHeight() == 0 ? 0 : d.getHeight()/rect.getHeight();
      double newRatio = (xRatio < yRatio ? xRatio : yRatio) ;
      ratio = ratio < newRatio  ? ratio: newRatio;
      if (rect.getHeight() < height )
        height = rect.getHeight() ;
    }
    fontSize *= ratio;
    t.reset();
    f = new Font(_font,style,(int)fontSize);
    height *= ratio;
    g2.setFont( f );
    //System.out.println( " - xRatio : "+xRatio +" - fontSize "+  fontSize);
    double pos = p.getY() +d.getHeight()/2 - ((t.length()-1)/2) *height;
    while ( t.hasNext() ) {
      String s = t.next();
      rect = f.getStringBounds(s, frc);
      g2.drawString(s , (int)(p.getX()+(d.getWidth() -rect.getWidth())/2),  (int)pos );
      pos += rect.getHeight();
    }
  }
  /**
   * Donne un Panel  la case
   */
  public void setPanel( MonopolyPanel panel)
  {
    _panel = panel;
  }
  public void redessine( boolean bErase )
  {
    final boolean b = bErase;
    class Dessinateur implements Runnable
    {
      public void run()
      {
        Graphics g = _panel.getGraphics();
        _panel.redessine( g , CaseG.this, b);
      }
    }
    try{
      // permet de dessiner  partir du Thred AWT .
      // C'est recommand, mais cela ne change rien dans les rsultats !
      SwingUtilities.invokeAndWait (  new Dessinateur(  ) );
    }catch(Exception ex)
    {
      System.out.println( ex .getMessage());
      ex.printStackTrace();
    }
  }
}