Imports Monopoly.Cases
Imports System.Drawing

Namespace IHM

  Public Class CaseG
    Protected Const HAUTEUR_ENTETE As Integer = 26

    Protected Const m_font As String = "Arial Narrow"
    Public Const LARGEUR_CASE As Integer = 40
    Public Const HAUTEUR_CASE As Integer = 66
    Protected m_case As CaseMonopoly

    Public Sub New(ByVal c As CaseMonopoly)
      m_case = c
    End Sub

    Public WriteOnly Property CaseDonnee() As CaseMonopoly
      Set(ByVal Value As CaseMonopoly)
        m_case = Value
      End Set
    End Property

    Public Sub DessineCadre(ByVal g As System.Drawing.Graphics, ByVal posx As Integer, ByVal posy As Integer)
      g.DrawRectangle(New Pen(Color.Black), posx, posy, LARGEUR_CASE, HAUTEUR_CASE)
    End Sub
    Public Sub DessineJoueurs(ByVal g As Graphics, ByVal centreX As Integer, ByVal centreY As Integer)
      '{
      '  int j = 0
      '  int nbJoueurs = _case.getListeJoueurs().size()
      '  int nbLignes = (nbJoueurs+1)/2
      '  centre dans la case

      '  final int LARGEUR_LIGNE = 12
      '  final int HAUTEUR_LIGNE = 12
      '  for(Iterator i = _case.getListeJoueurs().iterator() i.hasNext() j ++){
      '    int nbDansLaLigne = (j == nbJoueurs-1 && ((nbJoueurs %2 ) == 1) ? 1: 2)
      '    Joueur joueur = (Joueur) i.next()

      '    int y = centreY -(nbLignes-1)*HAUTEUR_LIGNE/2 + j/2*HAUTEUR_LIGNE
      '    int x = centreX + -((nbDansLaLigne+1)%2)*LARGEUR_LIGNE/2 + LARGEUR_LIGNE*(j%2 )

      '    joueur.getJoueurG().dessine( g, x, y)
      '  }
      '}
    End Sub

    Public Sub DessineCase(ByVal g As Graphics, ByVal posx As Integer, ByVal posy As Integer, ByVal bErase As Boolean)
      g.FillRectangle(New SolidBrush(Color.White), posx, posy, LARGEUR_CASE, HAUTEUR_CASE)

      DessineDetailsSpecifiques(g, posx, posy)

      DessineCadre(g, posx, posy)

      DessineJoueurs(g, posx + LARGEUR_CASE \ 2, posy + HAUTEUR_CASE \ 2)
    End Sub

    Public Overridable Sub DessineDetailsSpecifiques(ByVal g As Graphics, ByVal posx As Integer, ByVal posy As Integer)
      DessineTexte(m_case.Nom, g, New Point(posx + LARGEUR_CASE \ 30, posy), _
                New Size(LARGEUR_CASE * 19 \ 20, HAUTEUR_CASE * 8 \ 10 \ 2))
    End Sub


    '
    '  Permet de dessiner les cases qui sont aux coins du jeu
    '
    Public Sub DessineCoin(ByVal g As Graphics, ByVal x As Integer, ByVal y As Integer)
      '  g.setTransform(t)
      '  g.setColor( Color.white )
      g.FillRectangle(New SolidBrush(Color.White), x - HAUTEUR_CASE + LARGEUR_CASE, y, HAUTEUR_CASE, HAUTEUR_CASE)
      '  g.setColor( Color.black )
      g.DrawRectangle(New Pen(Color.Black), x - HAUTEUR_CASE + LARGEUR_CASE, y, HAUTEUR_CASE, HAUTEUR_CASE)

      DessineTexte(m_case.Nom, g, New Point(x - HAUTEUR_CASE + LARGEUR_CASE + HAUTEUR_CASE \ 10, y + HAUTEUR_CASE * 2 \ 5), New Size(HAUTEUR_CASE * 8 \ 10, HAUTEUR_CASE \ 5))

      'DessineJoueurs(g,t ,x+HAUTEUR_CASE/2  -HAUTEUR_CASE +LARGEUR_CASE ,y+HAUTEUR_CASE/2 )
      '}
      '
      ' Dessine du texte centr dans un cadre en s'aidant de @see TextSplitter
      ' 
    End Sub

    Protected Sub DessineTexte(ByVal sToDraw As String, ByVal g As Graphics, ByVal p As Point, ByVal rectDispo As Size)
      If sToDraw Is Nothing Or sToDraw = "" Then
        Exit Sub
      End If

      Dim fontSize As Double = 8
      Dim font As New Font(m_font, 8)
      Dim ratio As Double = 10000000000000.0
      Dim t As TextSplitter = New TextSplitter(sToDraw)
      Dim height As Double = 10000000.0
      Dim sf As SizeF

      sf = g.MeasureString(sToDraw, font)
      While t.MoveNext
        Dim s As String = t.Current
        font = New Font(m_font, CInt(fontSize))

        sf = g.MeasureString(sToDraw, font)
        Dim xRatio As Double
        If sf.Width = 0 Then
          xRatio = 0
        Else
          xRatio = rectDispo.Width / sf.Width
        End If

        Dim yRatio As Double
        If sf.Height = 0 Then
          yRatio = 0
        Else
          yRatio = rectDispo.Height / sf.Height
        End If

        Dim newRatio As Double = Math.Min(xRatio, yRatio)

        ratio = Math.Min(ratio, newRatio)

        If (sf.Height < height) Then
          height = sf.Height
        End If
      End While

      fontSize = fontSize * ratio

      t.Reset()
      font = New Font(m_font, CInt(fontSize))
      height = height * ratio

      Dim posY As Double = p.Y + rectDispo.Height / 2 - ((t.Length() - 1) / 2) * height
      While t.MoveNext
        Dim s As String = t.Current.ToString()
        sf = g.MeasureString(s, font)

        ' le dessin est align avec la position y verticale
        g.DrawString(s, font, New SolidBrush(Color.Black), _
          (p.X + (rectDispo.Width - sf.Width) / 2), CInt(posY - sf.Height / 2))

        '        g.DrawLine(New Pen(Color.Red), p.X, CInt(posY), p.X + 20, CInt(posY))

        posY = posY + sf.Height
      End While
    End Sub
    '
    ' Donne un Panel  la case
    '
    'public void setPanel( MonopolyPanel panel)
    '{
    '  _panel = panel
    '}
    'public void redessine( boolean bErase )
    '{
    '  final boolean b = bErase
    '  class Dessinateur implements Runnable
    '  {
    '    public void run()
    '    {
    '      Graphics g = _panel.getGraphics()
    '      _panel.redessine( g , CaseG.this, b)
    '    }
    '  }
    '  try{
    '     permet de dessiner  partir du Thred AWT .
    '     C'est recommand, mais cela ne change rien dans les rsultats !
    '    SwingUtilities.invokeAndWait (  new Dessinateur(  ) )
    '  }catch(Exception ex)
    '  {
    '    System.out.println( ex .getMessage())
    '    ex.printStackTrace()
    '  }
    '}
  End Class
End Namespace