Imports Monopoly3_graphique.Cases

Namespace IHM

/**
 * Titre :        Monopoly - version 3 - graphique
 * Description :
 * Copyright :    Copyright (c) 2001
 * Socit :      ***
 * @author Emmanuel DURIN
 * @version 1.0
 */
import monopoly.joueur.*;
import java.awt.*;

/**
 * JoueurG dessine le joueur
 * Elle est srialisable pour permettre  un joueur de se sauvegarder avec la bonne couleur
 */
public class JoueurG implements java.io.Serializable {
  private Joueur _j;
  private Color _color;
  public JoueurG( Joueur j, String color) {
    _j = j;
    try{
      _color = (Color)Class.forName("java.awt.Color").getField(color).get(null);
    }catch ( Exception e ){
      _color = Color.black;
    }
  }
  /**
   * Dessine le joueur sur la case
   * La position (x,y) est relative au coin suprieur gauche de la case
   */
  public void dessine( Graphics2D g2, int x ,int y)
  {
    int HAUTEUR = 12;
    int DELTA = 4;
    g2.setColor( Color.black );
    g2.fillOval(x-HAUTEUR/2, y-HAUTEUR/2, HAUTEUR, HAUTEUR );
    g2.setColor( _color );
    g2.fillOval(x-(HAUTEUR-DELTA)/2, y-(HAUTEUR-DELTA)/2, HAUTEUR-DELTA, HAUTEUR-DELTA );
  }
}


End Namespace
