Imports System.IO


Namespace Cases

  Public Class Plateau
    Public Const MAX_CASES As Integer = 40
    ' Allocation du tableau
    Private m_cases(MAX_CASES - 1) As CaseMonopoly

    Public ReadOnly Property ListeCase() As CaseMonopoly()
      Get
        Return m_cases
      End Get
    End Property

    Private Enum INDEX_IN_LINE As Integer
      POS_NOM
      POS_POS
      POS_PRIX
      POS_LOYER
      POS_GROUPE
    End Enum

    Private Function CreerDictionnaireCases() As IDictionary
      Dim table As IDictionary = New Hashtable(MAX_CASES)
      Dim reader As StreamReader
      Try
        reader = New StreamReader(New FileStream("..\monopoly lots.txt", FileMode.Open))
        Dim ligne As String
        Do
          ligne = reader.ReadLine()
          If Not ligne Is Nothing Then
            Dim tabSeparator() As Char = {","c}
            Dim tokens() As String = ligne.Split(tabSeparator)
            Dim nom, sLoyer, sPrix, sPos As String
            Dim iLoyer, iPrix, iPos As Integer

            Dim groupe As String = tokens(INDEX_IN_LINE.POS_GROUPE).Trim()

            iPrix = Integer.Parse(tokens(INDEX_IN_LINE.POS_PRIX))
            iLoyer = Integer.Parse(tokens(INDEX_IN_LINE.POS_LOYER))
            iPos = Integer.Parse(tokens(INDEX_IN_LINE.POS_POS)) - 1
            Dim p As Propriete
            Select Case (groupe)
              Case "Railroad"
                p = New Gare(tokens(INDEX_IN_LINE.POS_NOM))
              Case "Utilities"
                p = New Compagnie(tokens(INDEX_IN_LINE.POS_NOM))
              Case Else
                p = New Terrain(tokens(INDEX_IN_LINE.POS_NOM), iPrix, iLoyer, groupe)
            End Select
            table.Add(iPos, p)
          End If
        Loop While Not ligne Is Nothing
        Console.WriteLine()
      Finally
        If Not reader Is Nothing Then
          reader.Close()
        End If
      End Try
      Return table
    End Function

    Public Sub New()
      Dim table As IDictionary = CreerDictionnaireCases()
      ' cration des 40 cases
      Dim i As Integer
      For i = 0 To MAX_CASES - 1
        Select Case (i)
          Case 0
            m_cases(i) = New CaseDepart()
          Case 4
            m_cases(i) = New CaseImpots()
          Case 38
            m_cases(i) = New CaseLuxe()
          Case Else
            m_cases(i) = CType(table(i), CaseMonopoly)
            If m_cases(i) Is Nothing Then
              m_cases(i) = New CaseMonopoly("Case " & i)
            End If
        End Select
      Next

      ' chanage des 40 cases
      For i = 0 To MAX_CASES - 1
        m_cases(i).Suivante = m_cases((i + 1) Mod MAX_CASES)
      Next
    End Sub

    Public ReadOnly Property Depart() As CaseMonopoly
      Get
        Return m_cases(0)
      End Get
    End Property
  End Class
End Namespace