Imports Monopoly.Cases
Imports System.Drawing
Imports System.Reflection


Namespace IHM

  Public Class TerrainG : Inherits CaseG
    Private m_color As Color

    Public Sub New(ByVal c As CaseMonopoly, ByVal color As String)
      MyBase.New(c)

      ' Obtention du type correspondant  la classe Color
      ' On pourra en lister ses mthodes, attributs, proprits, constructeurs
      Dim t As Type = GetType(System.Drawing.Color)
      ' On retrouve ici la Proprit qui correspond  la couleur recherche
      Dim f As PropertyInfo = t.GetProperty(color)
      If f Is Nothing Then
        m_color = System.Drawing.Color.White
      Else
        Dim o As Object = f.GetValue(Nothing, Nothing)
        m_color = CType(o, System.Drawing.Color)

        ' le code prcdent est quivalent  
        ' m_color = Color.Green [ | Red,...]
        ' sauf que prcdemment on n'tait pas capable
        ' d'crire le nom de la couleur en dur.
      End If
    End Sub

    Public Overrides Sub DessineDetailsSpecifiques(ByVal g As Graphics, ByVal posx As Integer, ByVal posy As Integer)

      ' remplissage du rectangle color
      g.FillRectangle(New SolidBrush(m_color), posx, posy, CaseG.LARGEUR_CASE, CaseG.HAUTEUR_ENTETE)
      ' trait sous le rectangle
      g.DrawLine(New Pen(Color.Black), posx, posy + HAUTEUR_ENTETE, posx + LARGEUR_CASE, posy + HAUTEUR_ENTETE)

      ' affichage du nom de la case
      DessineTexte(m_case.Nom, g, New Point(posx + 1, posy), _
          New Size(LARGEUR_CASE - 2, HAUTEUR_ENTETE))

      ' affichage du prix
      Dessinetexte(CType((m_case), Propriete).Prix.ToString(), g, _
                  New Point(posx + LARGEUR_CASE \ 10, _
                  posy + HAUTEUR_ENTETE + (HAUTEUR_CASE - HAUTEUR_ENTETE) * 15 \ 30), _
                  New Size(LARGEUR_CASE * 8 \ 10, (HAUTEUR_CASE - HAUTEUR_ENTETE) \ 5))

      DessineJoueurs(g, posx + LARGEUR_CASE \ 2, posy + HAUTEUR_CASE \ 2)
    End Sub
  End Class

End Namespace