Imports Monopoly.Cases
Imports System.Collections

Public Class Joueur
    Private m_nom As String
    Private m_caseCourante As CaseMonopoly
    Private m_argent As Integer
    Private m_proprietes As New ArrayList()
    Private m_dernierJet As Integer

    Public Sub New(ByVal nom As String, ByVal caseCourante As CaseMonopoly)
        m_nom = nom
        m_caseCourante = caseCourante
        m_argent = 1500
    End Sub

    Public Sub Crediter(ByVal montant As Integer)
        m_argent = m_argent + montant
    End Sub
    Public Sub Debiter(ByVal montant As Integer)
        m_argent = m_argent - montant
        If m_argent <= 0 Then
            Dim p As Propriete
            For Each p In m_proprietes
                p.Proprietaire = Nothing
                p.Etat = EtatNonPossede.CreateEtatNonPossede()
            Next
            Throw New ExceptionJoueurAPerdu(Me)
        End If
    End Sub

    Public Sub Acquerir(ByVal propriete As Propriete)
        m_proprietes.Add(propriete)
    End Sub

    Public ReadOnly Property DernierJet() As Integer
        Get
            Return m_dernierJet
        End Get
    End Property

    Public ReadOnly Property Argent() As Integer
        Get
            Return m_argent
        End Get
    End Property

    Public ReadOnly Property Nom() As String
        Get
            Return m_nom
        End Get
    End Property

    Public Property Courante() As CaseMonopoly
        Get
            Return m_caseCourante
        End Get
        Set(ByVal Value As CaseMonopoly)
            m_caseCourante = Value
        End Set
    End Property

    Public Sub Jouer()
        m_dernierJet = Gobelet.Instance.Roll()
        Console.Write(Nom & " a obtenu " & m_dernierJet & " - ")
        Dim i As Integer
        For i = 1 To m_dernierJet - 1
            m_caseCourante = m_caseCourante.Suivante
            m_caseCourante.PasserParDessus(Me)
        Next
        m_caseCourante = m_caseCourante.Suivante
        m_caseCourante.Accueillir(Me)
    End Sub
End Class
