Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports Monopoly.Cases

Namespace IHM

  Public Class MonopolyForm
    Inherits System.Windows.Forms.Form

    Private Const HAUTEUR_PLATEAU As Integer = CaseG.LARGEUR_CASE * 9 + CaseG.HAUTEUR_CASE * 2
    Private Const LARGEUR_PLATEAU As Integer = HAUTEUR_PLATEAU
    Private pos_initiales(,) As Integer = {{CaseG.HAUTEUR_CASE, HAUTEUR_PLATEAU - CaseG.LARGEUR_CASE}, _
                            {CaseG.LARGEUR_CASE, CaseG.HAUTEUR_CASE}, _
                            {LARGEUR_PLATEAU - CaseG.HAUTEUR_CASE, CaseG.LARGEUR_CASE}, _
                            {LARGEUR_PLATEAU - CaseG.LARGEUR_CASE, HAUTEUR_PLATEAU - CaseG.HAUTEUR_CASE}}
    Private increments(,) As Integer = {{0, -CaseG.LARGEUR_CASE}, _
                                        {CaseG.LARGEUR_CASE, 0}, _
                                        {0, CaseG.LARGEUR_CASE}, _
                                        {-CaseG.LARGEUR_CASE, 0}}

    Private m_casesG As New ArrayList(Plateau.MAX_CASES - 1)

    Private m_scale As Double
    Private m_partie As Partie

#Region " Code gnr par le Concepteur Windows Form "


    Public Sub New(ByVal p As Partie)
      MyBase.New()

      ' Pour que le dessin de la fentre se fasse entirement lors
      ' d'un redimensionnement de la fentre
      ' Sinon la partie dj affiche n'est pas redessine.
      ResizeRedraw = True

      Dim i As Integer = 0
      Dim listCase() As CaseMonopoly = p.Plateau.ListeCase
      Dim c As CaseMonopoly
      For Each c In listCase
        '    c.getCaseG().setPanel(this);
        m_casesG.Add(c.CaseG)
        i = i + 1
      Next

      m_partie = p
      'Cet appel est requis par le Concepteur Windows Form.
      InitializeComponent()

      'Ajoutez une initialisation quelconque aprs l'appel InitializeComponent()
    End Sub

    'La mthode substitue Dispose du formulaire pour nettoyer la liste des composants.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
      If disposing Then
        If Not (components Is Nothing) Then
          components.Dispose()
        End If
      End If
      MyBase.Dispose(disposing)
    End Sub

    'Requis par le Concepteur Windows Form
    Private components As System.ComponentModel.IContainer

    'REMARQUE: la procdure suivante est requise par le Concepteur Windows Form
    'Elle peut tre modifie en utilisant le Concepteur Windows Form.  
    'Ne la modifiez pas en utilisant l'diteur de code.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
      '
      'MonopolyForm
      '
      Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
      Me.ClientSize = New System.Drawing.Size(292, 273)
      Me.Name = "MonopolyForm"
      Me.Text = "MonopolyForm"

    End Sub

#End Region


    Private Sub MonopolyForm_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
      Dim g As Graphics = e.Graphics

      'g.FillRectangle(New SolidBrush(Color.Bisque), Me.DisplayRectangle)
      Dim cG As CaseG
      For Each cG In m_casesG
        Redessine(g, cG, False)
      Next
    End Sub

    ' dessine juste une des 40 cases :
    ' prpare les transformations gomtriques
    ' et laisse  la case le soin de se dessiner
    Public Sub Redessine(ByVal g As Graphics, ByVal c As CaseG, ByVal bErase As Boolean)

      Dim index As Integer = Me.m_casesG.IndexOf(c)
      Dim CASES_LIGNES As Integer = Plateau.MAX_CASES \ 4
      Dim indexDansLigne As Integer = index Mod CASES_LIGNES
      Dim ligne As Integer = index \ CASES_LIGNES
      Dim angle As Integer = 90 * (ligne + 1)

      Dim h As Integer = ClientSize.Height
      Dim w As Integer = ClientSize.Width

      If w > h Then
        m_scale = h
      Else
        m_scale = w
      End If

      m_scale /= ((CASES_LIGNES - 1) * CaseG.LARGEUR_CASE + 2 * CaseG.HAUTEUR_CASE)

      Dim x As Integer = pos_initiales(ligne, 0)
      Dim y As Integer = pos_initiales(ligne, 1)

      If indexDansLigne > 0 Then
        If increments(ligne, 0) <> 0 Then
          x += CaseG.HAUTEUR_CASE * Math.Sign(increments(ligne, 0))
        End If
        If increments(ligne, 1) <> 0 Then
          y += CaseG.HAUTEUR_CASE * Math.Sign(increments(ligne, 1))
        End If
        x += increments(ligne, 0) * (indexDansLigne - 1)
        y += increments(ligne, 1) * (indexDansLigne - 1)
      End If

      g.ScaleTransform(CSng(m_scale), CSng(m_scale))
      g.TranslateTransform(x, y)
      g.RotateTransform(angle)
      Dim cg As CaseG = CType(m_casesG(indexDansLigne + ligne * CASES_LIGNES), CaseG)
      If indexDansLigne = 0 Then
        cg.DessineCoin(g, 0, 0)
      Else
        cg.DessineCase(g, 0, 0, False)
      End If
      g.ResetTransform()
    End Sub

    Public Sub New()

    End Sub
  End Class
End Namespace