package monopoly.gui;

/**
 * Titre :        Monopoly - version 3 - graphique
 * Description :
 * Copyright :    Copyright (c) 2001
 * Socit :      ***
 * @author Emmanuel DURIN
 * @version 1.0
 */

import monopoly.gui.text.MonopolyWriter;
/**
 * Coupe un texte en deux en cherchant l'espace le plus proche du milieu
 */
public class TextSplitter {
  private String [] _s;
  private int _counter = 0;
  private int _length;
  public TextSplitter( String s) {
    int left, right;
    left = right = s.length()/2;
    int spacePos = -1;
    while( left != 0 || right < s.length() ){
      if ( s.charAt(left) == ' '){
        spacePos = left;
        break;
      }
      if ( left != 0){
        left--;
      }
      if ( s.charAt(right) == ' '){
        spacePos = right;
        break;
      }
      if (right < s.length() ){
        right++;
      }
    }
    _length = spacePos == -1 ? 1 : 2;
    _s = new String[_length];
    if (_length ==1 ){
      _s[0] = s;
    }else{
      _s[0] = s.substring(0, spacePos);
      _s[1] = s.substring(spacePos+1, s.length());
    }
  }
  public boolean hasNext()
  {
    return _counter < _length;
  }
  public String next()
  {
    if (_counter >=_length)
      return null;
    else
      return _s[_counter++];
  }
  public int length()
  {
    return _length;
  }
  /**
   * fonction prsente pour des besoins de test
   */
  public static void main( String [] args)
  {
    String   s[] = {"Rue de la paix",
    "Gare",
     "Gare Montparnasse",
     "Compagnie d'lectricit" };
    for (int i =0; i< s.length; i++){
      TextSplitter t = new TextSplitter( s[i] );
      for (int j =0; j< t.length(); j++){
        System.out.println( t.next() ) ;
      }
      System.out.println("");
    }
  }
  public void reset()
  {
    _counter = 0;
  }
}