package monopoly.gui.text;

/**
 * Titre :        Monopoly - version 3 - graphique
 * Description :
 * Copyright :    Copyright (c) 2001
 * Socit :      ***
 * @author Emmanuel DURIN
 * @version 1.0
 */
import java.io.*;

public class MonopolyWriter {

  private static MonopolyWriter theInstance = null;


  private PrintStream printStream;
  /**
   * Cette classe est implmente sous la forme de singleton
   */
  private MonopolyWriter() {
    printStream = System.out;
  }
  private MonopolyWriter( PrintStream p) {
    printStream = p;
  }
  public static MonopolyWriter getMonopolyWriter( )
  {
    return getMonopolyWriter( null );
  }
  public static MonopolyWriter getMonopolyWriter( PrintStream p)
  {
    if ( theInstance == null){
      if (p == null ){
        theInstance = new MonopolyWriter();
      }else{
        theInstance = new MonopolyWriter(p);
      }
    }
    return theInstance;
  }
  public void println( String s )
  {
    printStream.println(s);
  }
  public void print( String s )
  {
    printStream.print(s);
  }
}