Namespace Cases
    Public Class Plateau
        Public Const MAX_CASES As Integer = 40
        ' Allocation du tableau
        Private m_cases(MAX_CASES - 1) As CaseMonopoly

        ReadOnly nomGares As String() = {"Gare Montparnasse", _
                                         "Gare de Lyon", _
                                         "Gare du nord", _
                                         "Gare Saint-Lazare"}
        Public Sub New()
            Dim numGare As Integer = 1
            Dim numCompagnie As Integer = 1
            Dim numTerrain As Integer = 1
            Dim i As Integer
            ' cration des 40 cases
            For i = 0 To MAX_CASES - 1
                Select Case (i)
                    Case 0
                        m_cases(i) = New CaseDepart()
                    Case 4
                        m_cases(i) = New CaseImpots()
                    Case 38
                        m_cases(i) = New CaseLuxe()
                    Case 5, 15, 25, 35
                        m_cases(i) = New Gare(nomGares(numGare))
                        numGare = numGare + 1
                    Case 12, 18
                        m_cases(i) = New Compagnie("Compagnie " & numCompagnie)
                        numCompagnie = numCompagnie + 1
                    Case 1, 3, 6, 8, 9, 11, 13, 14, 16, 18, 19, 21, 23, 24, 26, 27, 29, 31, 32, 34, 37, 39
                        m_cases(i) = New Terrain("Terrain " & numTerrain, 40 + i * 10, i)
                        numTerrain = numTerrain + 1
                    Case Else
                        m_cases(i) = New CaseMonopoly("Case " & i)
                End Select
            Next

            ' chanage des 40 cases
            For i = 0 To MAX_CASES - 1
                m_cases(i).Suivante = m_cases((i + 1) Mod MAX_CASES)
            Next
        End Sub

        Public ReadOnly Property Depart() As CaseMonopoly
            Get
                Return m_cases(0)
            End Get
        End Property
    End Class
End Namespace