
Namespace Cases
    Public Class EtatNonPossede
        Implements Etat

        Private Shared m_instance As New EtatNonPossede()

        ' On cache le constructeur de la classe car on veut 
        ' pas que l'utilisateur puisse crer lui mme 
        ' une instance de la classe. Il faut qu'il passe par la mthode de
        ' fabrique CreateEtatPossede() qui pour l'instant ne cre et n'utilise
        ' qu'une seule instance.
        ' Ca permettra ensuite d'utiliser plusieurs instances distinctes si ncessaire.
        Protected Sub New()
        End Sub

        Sub Accueillir(ByVal p As Propriete, ByVal j As Joueur) Implements Etat.Accueillir
            If j.Argent >= p.Prix Then
                j.Debiter(p.Prix)
                j.Acquerir(p)
                p.Etat = EtatPossede.CreateEtatPossede()
                p.Proprietaire = j
                Console.WriteLine(j.Nom & " acquiert " & p.Nom)
            Else
                Console.WriteLine(j.Nom & " n'a pas assez d'argent pour acqurir " & p.Nom)
            End If
        End Sub

        Public Shared Function CreateEtatNonPossede() As EtatNonPossede
            Return m_instance
        End Function
    End Class
End Namespace
