Imports System.IO

Namespace Cases
  Public Class Plateau
    Public Const MAX_CASES As Integer = 40
    ' Allocation du tableau
    Private m_cases(MAX_CASES - 1) As CaseMonopoly

    Private Enum INDEX_IN_LINE As Integer
      POS_NOM
      POS_POS
      POS_PRIX
      POS_LOYER
      POS_GROUPE
        End Enum

        Private Function LireCases() As CaseMonopoly()
            Dim table(MAX_CASES) As CaseMonopoly
            Dim reader As StreamReader = Nothing
            Try
                reader = New StreamReader(New FileStream("..\monopoly lots.txt", FileMode.Open))
                Dim ligne As String
                Do ' boucle sur les lignes du fichier
                    ligne = reader.ReadLine()
                    If Not ligne Is Nothing Then
                        Dim tabSeparator() As Char = {","c}
                        Dim tokens() As String = ligne.Split(tabSeparator)
                        Dim iLoyer, iPrix, iPos As Integer
                        ' conversion des Strings lus en int, etc...
                        iPrix = CInt(tokens(INDEX_IN_LINE.POS_PRIX))
                        iLoyer = CInt(tokens(INDEX_IN_LINE.POS_LOYER))
                        iPos = CInt(tokens(INDEX_IN_LINE.POS_POS))
                        Dim p As Propriete
                        Select Case (tokens(INDEX_IN_LINE.POS_GROUPE))
                            Case "RailRoad"
                                p = New Gare(tokens(INDEX_IN_LINE.POS_NOM))
                            Case "Utilities"
                                p = New Compagnie(tokens(INDEX_IN_LINE.POS_NOM))
                            Case Else
                                p = New Terrain(tokens(INDEX_IN_LINE.POS_NOM), iPrix, iLoyer)
                        End Select
                        table(iPos) = p
                    End If
                Loop While Not ligne Is Nothing
                Console.WriteLine()
            Finally
                If reader IsNot Nothing Then
                    reader.Close()
                End If
            End Try
            Return table
        End Function

    Public Sub New()
            Dim table As CaseMonopoly() = LireCases()
      ' cration des 40 cases
      Dim i As Integer
      For i = 0 To MAX_CASES - 1
        Select Case (i)
          Case 0
            m_cases(i) = New CaseDepart()
          Case 4
            m_cases(i) = New CaseImpots()
          Case 38
            m_cases(i) = New CaseLuxe()
          Case Else
                        m_cases(i) = table(i)
            If m_cases(i) Is Nothing Then
              m_cases(i) = New CaseMonopoly("Case " & i)
            End If
        End Select
      Next

      ' chanage des 40 cases
      For i = 0 To MAX_CASES - 1
        m_cases(i).Suivante = m_cases((i + 1) Mod MAX_CASES)
      Next
    End Sub

    Public ReadOnly Property Depart() As CaseMonopoly
      Get
        Return m_cases(0)
      End Get
    End Property
  End Class
End Namespace