
Public Class Player
  Implements IComparable

  Private m_die1, m_die2 As New Die()
  Private m_score As Integer
  Private m_name As String

  Public Sub New(ByVal name As String)
    m_name = name
  End Sub

  Public ReadOnly Property Name() As String
    Get
      Return m_name
    End Get
  End Property
  Public ReadOnly Property Score() As Integer
    Get
      Return m_score
    End Get
  End Property

  Public Sub TakeTurn()
    Dim r1 As Integer = m_die1.Roll()
    Dim r2 As Integer = m_die2.Roll()
    If r1 + r2 >= 7 Then
      IncreaseScore()
    End If
    Console.WriteLine(m_name & " joue. Son score est de " & m_score)
  End Sub

  ' l'accs au score  travers des proprits permettrait par la suite 
  ' d'ajouter des services dans les mthodes d'accs aux proprits.
  ' On bnficierait aussi de ces services lors de l'appel de IncreaseScore
  '
  ' Cependant cela ncessiterait que Set soit crite et donc utilisable
  ' en dehors de la class => rupture de l'encapsulation
  '
  ' On se contentera donc d'accder  l'attribut dans la classe.
  ' C'est tout  fait tolrable car la classe est experte d'elle mme.
  ' Qui d'autre que la classe a le droit d'accder  ses attributs ?
  Private Sub IncreaseScore()
    m_score = m_score + 1
  End Sub

  Public Function CompareTo(ByVal o As Object) As Integer Implements IComparable.CompareTo
    Dim j As Player = CType(o, Player)
    Return Me.m_score - j.m_score
  End Function


End Class
