Imports NUnit.Framework
Imports NMock


Namespace Tests
    <TestFixture()> Public Class TestPlayer
        Private MAX_ROLL As Integer = 100

        Private Function CreateMockDie(ByVal value As Integer) As Die
            Dim dieType As Type = Type.GetType("p187_Nmock.Die")

            Dim myMock As Mock
            myMock = New DynamicMock(dieType)
            myMock.SetupResult("Roll", value)

            Dim mockDie As Die
            mockDie = CType(myMock.MockInstance, Die)
            Return mockDie
        End Function

        <Test()> Public Sub TestAvecBouchon()
            ' NS or not NS ?
            ' -Le nom de la classe que l'on veut "mocker"  
            ' doit  tre qualifi de son NS : "p187_Nmock.Die"

            Dim p As New Player("cobaye", CreateMockDie(3), CreateMockDie(3))
            Dim i As Integer
            For i = 1 To MAX_ROLL
                p.TakeTurn()
            Next i
            'myMock.Verify()
            Assert.AreEqual(0, p.Score)

            p = New Player("cobaye2", CreateMockDie(6), CreateMockDie(6))
            For i = 1 To MAX_ROLL
                p.TakeTurn()
            Next i
            'myMock.Verify()
            Assert.AreEqual(MAX_ROLL, p.Score)
        End Sub


        <Test()> Sub TestStatistique()
            ' le joueur gagne statistiquement 21 fois sur 36
            Const MAX_ROLL As Integer = 1000000
            Dim i As Integer
            Dim p As New Player("cobaye", New Die(), New Die())
            For i = 1 To MAX_ROLL
                p.TakeTurn()
            Next
            Console.WriteLine(p.Score)
            Console.WriteLine(MAX_ROLL * 21 * 11 / (36 * 10))
            Console.WriteLine(MAX_ROLL * 21 * 9 / (36 * 10))
            Assert.IsTrue((p.Score < (MAX_ROLL * 21 * 11 / (36 * 10))) And (p.Score > (MAX_ROLL * 21 * 9 / (36 * 10))), "Le score du joueur devrait tendre ....")
        End Sub

    End Class
End Namespace